//+------------------------------------------------------------------+
//|                                               Pattern_Stat_2.mq5 |
//|                                        Copyright 2012, her.human |
//|                                              her.human@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, her.human"
#property link      "her.human@gmail.com"
#property version   "2.00"

#include <Trade\Trade.mqh>

//-----------input variable----------------
input double 	lot = 1;
input double 	forgetting = 0.02; 			//  0.0- , 1.0- 
input int 		MinBarsStatisyic = 3000; 	//    
input int 		min_primer = 5; 				//   
input double   porog_open=0.8; 				//        0.0  1.0
input double   porog_clos=0.05; 				//     
input bool     CloseProfitOnly=false;     //       
input bool 		revers = false;  				//   

input int      bars_future=28;				//    
input double   porog=0.001;					//     0.0  1.0

input string  	param_signal = "-----    1  17-----"; //-------------------- 
input int 		nsig1 = 1; 						//     1
input int 		nsig2 = 2; 						//     2
input int 		nsig3 = 9; 						//     3
input int 		nsig4 = 13; 						//     4
input int 		nsig5 = 8; 						//     5
input int 		nsig6 = 10; 						//     6
input int 		nsig7 = 12; 						//     7
input int 		nsig8 = 4; 						//     8
input int 		nsig9 = 10; 						//     9
input int 		nsig10 = 14; 					//     10

input string  	param_ma1 = "----- 1-----"; //-------------------- 
input int                  ma_period1=33;                 //   1
input int                  ma_shift1=0;                   //  1
input ENUM_MA_METHOD       ma_method1=MODE_EMA;           //   1
input ENUM_APPLIED_PRICE   applied_price1=PRICE_OPEN;     //   1
//input string               symbol1=" ";                 //  1
input ENUM_TIMEFRAMES      period1=PERIOD_CURRENT;        //  1

input string  	param_ma2 = "----- 2-----"; //-------------------- 
input int                  ma_period2=6;                  //   2
input int                  ma_shift2=0;                   //  2
input ENUM_MA_METHOD       ma_method2=MODE_SMA;           //   2
input ENUM_APPLIED_PRICE   applied_price2=PRICE_OPEN;     //   2
//input string               symbol2=" ";                 //  2
input ENUM_TIMEFRAMES      period2=PERIOD_H12;            //  2

//-----------global variables----------------
CTrade trade;
MqlTick tick;
MqlDateTime stime;
int handle_ma1, handle_ma2;
double point;
double ma1[], ma2[], open[], high[], low[];
int arr_in[10];
double arr_buy[1024], arr_sell[1024];
datetime time[], prevtime;
int bars;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   bars=0;
   ArrayInitialize(arr_buy,0.00001);
   ArrayInitialize(arr_sell,0.00001);
   ArraySetAsSeries(ma1,true);
   ArraySetAsSeries(ma2,true);
   ArraySetAsSeries(open,true);
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);
   point=SymbolInfoDouble(_Symbol,SYMBOL_POINT);
   handle_ma1=iMA(_Symbol,period1,ma_period1,ma_shift1,ma_method1,applied_price1);
   handle_ma2=iMA(_Symbol,period2,ma_period2,ma_shift2,ma_method2,applied_price2);
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   IndicatorRelease(handle_ma1);
   IndicatorRelease(handle_ma2);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//   
   CopyTime(_Symbol,PERIOD_CURRENT,0,1,time);
   if(prevtime==time[0]) return;
   prevtime=time[0];
   
   bars++; //    ()
   
   arr_in[0]=signal(nsig1,bars_future);
   arr_in[1]=signal(nsig2,bars_future);
   arr_in[2]=signal(nsig3,bars_future);
   arr_in[3]=signal(nsig4,bars_future);
   arr_in[4]=signal(nsig5,bars_future);
   arr_in[5]=signal(nsig6,bars_future);
   arr_in[6]=signal(nsig7,bars_future);
   arr_in[7]=signal(nsig8,bars_future);
   arr_in[8]=signal(nsig9,bars_future);
   arr_in[9]=signal(nsig10,bars_future);
   
   int index=arr2int(arr_in); //       
   double forgett=(1.0-forgetting);
   arr_buy[index]*=forgett;   //   ,  
   arr_sell[index]*=forgett;  //   ,  
   
   CopyHigh(_Symbol,PERIOD_CURRENT,1,bars_future,high);
   CopyLow(_Symbol,PERIOD_CURRENT,1,bars_future,low);
   CopyOpen(_Symbol,PERIOD_CURRENT,1,bars_future,open);
   
   //---    ,  bars_future 
   double deviation_plus=high[ArrayMaximum(high,0,bars_future)]-open[bars_future-1];
   //---    ,  bars_future 
   double deviation_minus=open[bars_future-1]-low[ArrayMinimum(low,0,bars_future)];
   //---         -1, +1,
   double value=(2.0*deviation_plus)/(deviation_plus+deviation_minus)-1;
   Print("arr_buy=",arr_buy[index],"   arr_sell[index]=",arr_sell[index]);
   if(value>porog) arr_buy[index]+=value;
   if(value<-porog) arr_sell[index]-=value;
   
   if(bars<MinBarsStatisyic) return; //         (MinBarsStatisyic) - 

//   
   arr_in[0]=signal(nsig1,0);
   arr_in[1]=signal(nsig2,0);
   arr_in[2]=signal(nsig3,0);
   arr_in[3]=signal(nsig4,0);
   arr_in[4]=signal(nsig5,0);
   arr_in[5]=signal(nsig6,0);
   arr_in[6]=signal(nsig7,0);
   arr_in[7]=signal(nsig8,0);
   arr_in[8]=signal(nsig9,0);
   arr_in[9]=signal(nsig10,0);
   
   index=arr2int(arr_in); //       
   
   double stat_sign=0.0;
   if(arr_buy[index]>0.1 && arr_sell[index]>0.1)
      stat_sign=2.0*((arr_buy[index])/(arr_buy[index]+arr_sell[index]))-1.0; //   
   if(revers) stat_sign*=-1.0;  //       revers
   SymbolInfoTick(_Symbol,tick);
//Print("stat_sign = ",stat_sign);
//        -         
   if(!PositionSelect(_Symbol) && arr_buy[index]+arr_sell[index]>min_primer)
     {
      if(stat_sign>porog_open) trade.Buy(lot,NULL,tick.ask,0,0);
      if(stat_sign<-porog_open) trade.Sell(lot,NULL,tick.bid,0,0);
     }
//       -          
   else
     {
      if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
        {
         if(stat_sign<-porog_open)
           { trade.Sell(lot*2); return; } //  
         if(stat_sign<porog_clos)
           {
           if(CloseProfitOnly)
             { if(PositionGetDouble(POSITION_PROFIT)>0.0) trade.PositionClose(_Symbol); } //     
           else trade.PositionClose(_Symbol); //      
           }
         return;
        }
      if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
        {
         if(stat_sign>porog_open)
           { trade.Buy(lot*2); return; } //  
         if(stat_sign>-porog_clos)
           {
           if(CloseProfitOnly)
             { if(PositionGetDouble(POSITION_PROFIT)>0.0) trade.PositionClose(_Symbol); } //     
           else trade.PositionClose(_Symbol); //      
           }
         return;
        }
     }  
  }
//+------------------------------------------------------------------+
int arr2int(int &arr[])
{
   int a = 0;
   int n = ArraySize(arr);
   for(int i = 0; i < n; i++)
      a |= arr[i] << i;
   return (a);
}
//+------------------------------------------------------------------+
//    
//+------------------------------------------------------------------+
int signal(int numsig, int shift)
  {
   int sig=0;
   switch(numsig)
     {
      case 1:
   CopyBuffer(handle_ma1,0,shift,2,ma1);
   if(ma1[0]>ma1[1]) sig=1;
      break;
      
      case 2:
   CopyBuffer(handle_ma2,0,shift,2,ma2);
   if(ma2[0]>ma2[1]) sig=1;
      break;
      
      case 3:
   CopyBuffer(handle_ma1,0,shift,3,ma1);
   if(ma1[1]>ma1[2]) sig=1;
      break;
      
      case 4:
   CopyBuffer(handle_ma2,0,shift,3,ma2);
   if(ma2[1]>ma2[2]) sig=1;
      break;
      
      case 5:
   CopyBuffer(handle_ma1,0,shift,1,ma1);
   CopyBuffer(handle_ma2,0,shift,1,ma2);
   if(ma1[0]>ma2[0]) sig=1;
      break;
      
      case 6:
   CopyBuffer(handle_ma1,0,shift,2,ma1);
   CopyBuffer(handle_ma2,0,shift,2,ma2);
   if(ma1[1]>ma2[1]) sig=1;
      break;
      
      case 7:
   CopyBuffer(handle_ma1,0,shift,1,ma1);
   CopyOpen(_Symbol,PERIOD_CURRENT,shift,1,open);
   if(open[0]>ma1[0]) sig=1;
      break;
      
      case 8:
   CopyBuffer(handle_ma2,0,shift,1,ma2);
   CopyOpen(_Symbol,PERIOD_CURRENT,shift,1,open);
   if(open[0]>ma2[0]) sig=1;
      break;
      
      case 9:
   CopyBuffer(handle_ma1,0,shift,2,ma1);
   CopyOpen(_Symbol,PERIOD_CURRENT,shift,2,open);
   if(open[1]>ma1[1]) sig=1;
      break;
      
      case 10:
   CopyBuffer(handle_ma2,0,shift,2,ma2);
   CopyOpen(_Symbol,PERIOD_CURRENT,shift,2,open);
   if(open[1]>ma2[1]) sig=1;
      break;
      
      case 11:
   CopyOpen(_Symbol,PERIOD_CURRENT,shift,2,open);
   if(open[0]>open[1]) sig=1;
      break;
      
      case 12:
   CopyOpen(_Symbol,PERIOD_CURRENT,shift,3,open);
   if(open[1]>open[2]) sig=1;
      break;
      
      case 13:
   CopyHigh(_Symbol,PERIOD_CURRENT,shift,3,high);
   if(high[1]>high[2]) sig=1;
      break;
      
      case 14:
   CopyLow(_Symbol,PERIOD_CURRENT,shift,3,low);
   if(low[1]>low[2]) sig=1;
      break;
      
      case 15:
   CopyTime(_Symbol,PERIOD_CURRENT,shift,1,time);
   TimeToStruct(time[0],stime);
   if(stime.hour>=12) sig=1;
      break;
      
      case 16:
   CopyTime(_Symbol,PERIOD_CURRENT,shift,1,time);
   TimeToStruct(time[0],stime);
   if(stime.hour>=12) sig=1;
   sig=(int)MathCeil((stime.hour-12*sig)/6); 
      break;
      
      case 17:
   CopyTime(_Symbol,PERIOD_CURRENT,shift,1,time);
   TimeToStruct(time[0],stime);
   sig=stime.hour%2;
      break;
      
      default: 
   CopyOpen(_Symbol,PERIOD_CURRENT,shift,2,open);
   if(open[0]>open[1]) sig=1;
     }
   return(sig);
  }
//+------------------------------------------------------------------+
  